﻿using System;
using System.Windows.Forms;

namespace OperationsMatrix
{
    public partial class frmMatrix : Form
    {
        private Matrix matrixA;
        private Matrix matrixB;

        public frmMatrix()
        {
            InitializeComponent();
        }

        private void btnSetMatrixSize_Click(object sender, EventArgs e)
        {
            int countsRows = Convert.ToInt32(editRows.Text);
            int countsCols = Convert.ToInt32(editCols.Text);
            //this.matrixA = new int[countsRows, countsCols];
            matrixA = Matrix.SetColAndRow(countsRows, countsCols);
            matrixB = Matrix.SetColAndRow(countsRows, countsCols);

            // Задание размеров для сетки матрицы А
            gridMatrixA.RowCount = countsRows;
            gridMatrixA.ColumnCount = countsCols;

            // Задание размеров для сетки матрицы В
            gridMatrixB.RowCount = countsRows;
            gridMatrixB.ColumnCount = countsCols;

            GridParams.SetColumnWidth(gridMatrixA, GridParams.COLUMN_WIDTH);
            GridParams.SetColumnWidth(gridMatrixB, GridParams.COLUMN_WIDTH);
            GridParams.SetRowsHeight(gridMatrixA, GridParams.ROWS_HEIGHT);
            GridParams.SetRowsHeight(gridMatrixB, GridParams.ROWS_HEIGHT);

            if (chkGenNumber.Checked)
            {
                matrixA.FillRandomNumber(GridParams.MIN_VALUE, GridParams.MAX_VALUE);
                matrixB.FillRandomNumber(GridParams.MIN_VALUE, GridParams.MAX_VALUE);
            }

            GridParams.FillGrids(gridMatrixA, matrixA);
            GridParams.FillGrids(gridMatrixB, matrixB);
        }

        private void btnCalk_Click(object sender, EventArgs e)
        {
            frmResults frmRes;

            if (radAdd.Checked)
            {
                frmRes = new frmResults(matrixA.Add(matrixB));
            } else
            {
                frmRes = new frmResults(matrixA.Sub(matrixB));
            }

            frmRes.ShowDialog();
            frmRes = null;
        }
    }
}
