﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace OperationsMatrix
{
    public class GridParams
    {
        public const int COLUMN_WIDTH = 60;
        public const int ROWS_HEIGHT = 60;
        public const int MIN_VALUE = -20;
        public const int MAX_VALUE = 20;

        public static void SetColumnWidth(DataGridView grid, int width)
        {
            for (int j = 0; j < grid.ColumnCount; j++)
            {
                grid.Columns[j].Width = width;
            }
        }

        public static void SetRowsHeight(DataGridView grid, int height)
        {
            for (int i = 0; i < grid.RowCount; i++)
            {
                grid.Rows[i].Height = height;
            }
        }

        public static void FillGrids(DataGridView visualGrid, Matrix arr)
        {
            int[,] elements = arr.GetMatrix();

            for (int i = 0; i < visualGrid.RowCount; i++)
                for (int j = 0; j < visualGrid.ColumnCount; j++)
                {
                    visualGrid.Rows[i].Cells[j].Value = elements[i, j].ToString();
                }
        }
    }
}
